/*********************************************************************NVMH3****
Path:  NVSDK\Common\media\cgfx
File:  viewer_fixedpipe_notexnew.fx

Copyright NVIDIA Corporation 2002
TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THIS SOFTWARE IS PROVIDED
*AS IS* AND NVIDIA AND ITS SUPPLIERS DISCLAIM ALL WARRANTIES, EITHER EXPRESS
OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL NVIDIA OR ITS SUPPLIERS
BE LIABLE FOR ANY SPECIAL, INCIDENTAL, INDIRECT, OR CONSEQUENTIAL DAMAGES
WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR ANY OTHER PECUNIARY LOSS)
ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF NVIDIA HAS
BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Comments:

******************************************************************************/
float4 ambientMaterial : Ambient < string UIWidget = "Color"; string Space = "material";> = {0.15f, 0.15f, 0.15f, 1.0};
float4 emissiveMaterial : Emissive < string UIWidget = "Color"; string Space = "material";> = {0.1, 0.1, 0.1, 1.0};
float4 specularMaterial : Specular < string UIWidget = "Color"; string Space = "material";> = {0.0, 0.0, 0.0, 1.0};
float4 diffuseMaterial : Diffuse < string UIWidget = "Color"; string Space = "material";> = {1.0, 1.0, 1.0, 1.0};
float powerMaterial : SpecularPower = 50.0;

bool alphaBlendEnable = false;
bool localViewerEnable = true;

texture diffuseTexture : Diffuse
<
	string ResourceName = "default_color.dds";
>;

// Lights
// Point lights
//0
bool pointlight0Enable
<
> = true;

float3 pointlight0Position : Position
<
	string Object ="PointLight";
	string Space = "DeviceLightSpace";

> = { 0.0f, 0.0f, -10.0f };

float4 pointlight0Diffuse : Diffuse
<
	string Object ="PointLight";
> = { 1.0f, 1.0f, 1.0f, 1.0f };

float4 pointlight0Specular : Specular
<
	string Object ="PointLight";
> = { .2f, .2f, .2f, 1.0f };

//1
bool pointlight1Enable
<
> = true;

float3 pointlight1Position : Position
<
	string Object ="PointLight";
	string Space = "DeviceLightSpace";
>;

float4 pointlight1Diffuse : Diffuse
<
	string Object ="PointLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 pointlight1Specular : Specular
<
	string Object ="PointLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

//2
bool pointlight2Enable
<

> = true;

float3 pointlight2Position : Position
<
	string Object ="PointLight";
	string Space = "DeviceLightSpace";
>;

float4 pointlight2Diffuse : Diffuse
<
	string Object ="PointLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 pointlight2Specular : Specular
<
	string Object ="PointLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

// Spotlights
//0
bool spotlight0Enable
<
> = true;

float3 spotlight0Position : Position
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
>;

float3 spotlight0Direction : Direction
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
> = {1.0f, 0.0f, 0.0f};

float4 spotlight0Diffuse : Diffuse
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 spotlight0Specular : Specular
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float spotlight0Penumbra : LightPenumbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight0Umbra : LightUmbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight0Falloff : LightFalloff
<
	string Object ="SpotLight";
> = 1.0f;

//1
bool spotlight1Enable
<
> = true;

float3 spotlight1Position : Position
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
>;

float3 spotlight1Direction : Direction
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
> = {1.0f, 0.0f, 0.0f};

float4 spotlight1Diffuse : Diffuse
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 spotlight1Specular : Specular
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float spotlight1Penumbra : LightPenumbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight1Umbra : LightUmbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight1Falloff : LightFalloff
<
	string Object ="SpotLight";
> = 1.0f;

//2
bool spotlight2Enable
<

> = true;

float3 spotlight2Position : Position
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
>;

float3 spotlight2Direction : Direction
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
> = {1.0f, 0.0f, 0.0f};

float4 spotlight2Diffuse : Diffuse
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 spotlight2Specular : Specular
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float spotlight2Penumbra : LightPenumbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight2Umbra : LightUmbra
<
	string Object ="SpotLight";
> = 0.0f;


float spotlight2Falloff : LightFalloff
<
	string Object ="SpotLight";
> = 1.0f;

//3
bool spotlight3Enable
<
> = true;

float3 spotlight3Position : Position
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
>;

float3 spotlight3Direction : Direction
<
	string Object ="SpotLight";
	string Space = "DeviceLightSpace";
> = {1.0f, 0.0f, 0.0f};

float4 spotlight3Diffuse : Diffuse
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float4 spotlight3Specular : Specular
<
	string Object ="SpotLight";
> = {0.0f, 0.0f, 0.0f, 0.0f};

float spotlight3Penumbra : LightPenumbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight3Umbra : LightUmbra
<
	string Object ="SpotLight";
> = 0.0f;

float spotlight3Falloff : LightFalloff
<
	string Object ="SpotLight";
> = 1.0f;

technique textured
{
	pass p0
	{
        Texture[0] = <diffuseTexture>;
  		MinFilter[0] = Linear;
  		MagFilter[0] = Linear;
  		MipFilter[0] = Linear;

		MaterialDiffuse = <diffuseMaterial>;
		MaterialSpecular = <specularMaterial>;
        MaterialAmbient  = <ambientMaterial>;
		MaterialEmissive = <emissiveMaterial>;
		MaterialPower = <powerMaterial>;

		// 3 Point lights
   		LightAttenuation0[0] = 1.0f;
		LightAttenuation1[0] = 0.0f;
		LightAttenuation2[0] = 0.0f;
        LightType[0]      = Point;
        LightDiffuse[0]   = <pointlight0Diffuse>;
        LightSpecular[0]  = <pointlight0Specular>; 
        LightAmbient[0]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[0]  = <pointlight0Position>;
        LightRange[0]     = 100000.0f;
		LightEnable[0] 	  = <pointlight0Enable>;

   		LightAttenuation0[1] = 1.0f;
		LightAttenuation1[1] = 0.0f;
		LightAttenuation2[1] = 0.0f;
        LightType[1]      = Point;
        LightDiffuse[1]   = <pointlight1Diffuse>;
        LightSpecular[1]  = <pointlight1Specular>; 
        LightAmbient[1]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[1]  = <pointlight1Position>;
        LightRange[1]     = 100000.0f;
		LightEnable[1] 	  = <pointlight1Enable>;

   		LightAttenuation0[2] = 1.0f;
		LightAttenuation1[2] = 0.0f;
		LightAttenuation2[2] = 0.0f;
        LightType[2]      = Point;
        LightDiffuse[2]   = <pointlight2Diffuse>;
        LightSpecular[2]  = <pointlight2Specular>; 
        LightAmbient[2]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[2]  = <pointlight2Position>;
        LightRange[2]     = 100000.0f;
		LightEnable[2] 	  = <pointlight2Enable>;

		// 4 Spot lights
   		LightAttenuation0[3] = 1.0f;
		LightAttenuation1[3] = 0.0f;
		LightAttenuation2[3] = 0.0f;
		LightPhi[3]		  = <spotlight0Penumbra>;
		LightTheta[3]	  = <spotlight0Umbra>;
        LightType[3]      = Spot;
        LightDiffuse[3]   = <spotlight0Diffuse>;
        LightSpecular[3]  = <spotlight0Specular>; 
        LightAmbient[3]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[3]  = <spotlight0Position>;
        LightDirection[3]  = <spotlight0Direction>;
        LightRange[3]     = 100000.0f;
		LightFalloff[3]   = <spotlight0Falloff>;
		LightEnable[3] 	  = <spotlight0Enable>;

		LightAttenuation0[4] = 1.0f;
		LightAttenuation1[4] = 0.0f;
		LightAttenuation2[4] = 0.0f;
		LightPhi[4]		  = <spotlight1Penumbra>;
		LightTheta[4]	  = <spotlight1Umbra>;
        LightType[4]      = Spot;
        LightDiffuse[4]   = <spotlight1Diffuse>;
        LightSpecular[4]  = <spotlight1Specular>; 
        LightAmbient[4]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[4]  = <spotlight1Position>;
		LightDirection[4]  = <spotlight1Direction>;
        LightRange[4]     = 100000.0f;
		LightFalloff[4]   = <spotlight1Falloff>;
		LightEnable[4] 	  = <spotlight1Enable>;

		LightAttenuation0[5] = 1.0f;
		LightAttenuation1[5] = 0.0f;
		LightAttenuation2[5] = 0.0f;
		LightPhi[5]		  = <spotlight2Penumbra>;
		LightTheta[5]	  = <spotlight2Umbra>;
        LightType[5]      = Spot;
        LightDiffuse[5]   = <spotlight2Diffuse>;
        LightSpecular[5]  = <spotlight2Specular>; 
        LightAmbient[5]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[5]  = <spotlight2Position>;
		LightDirection[5]  = <spotlight2Direction>;
        LightRange[5]     = 100000.0f;
		LightFalloff[5]   = <spotlight2Falloff>;
		LightEnable[5] 	  = <spotlight2Enable>;

		LightAttenuation0[6] = 1.0f;
		LightAttenuation1[6] = 0.0f;
		LightAttenuation2[6] = 0.0f;
		LightPhi[6]		  = <spotlight3Penumbra>;
		LightTheta[6]	  = <spotlight3Umbra>;
        LightType[6]      = Spot;
        LightDiffuse[6]   = <spotlight3Diffuse>;
        LightSpecular[6]  = <spotlight3Specular>; 
        LightAmbient[6]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[6]  = <spotlight3Position>;
		LightDirection[6]  = <spotlight3Direction>;
        LightRange[6]     = 100000.0f;
		LightFalloff[6]   = <spotlight3Falloff>;
		LightEnable[6] 	  = <spotlight3Enable>;

		// Enable lighting and turn light 0 on.
        
        Lighting = true;
        LocalViewer = <localViewerEnable>;

   		ZEnable = true;
		ZWriteEnable = true;

        DiffuseMaterialSource = Material;
  		SpecularMaterialSource = Material;
  		AmbientMaterialSource = Material;
  		EmissiveMaterialSource = Material;

        // Assign diffuse color to be used
        ColorOp[0]   = Modulate;
        ColorArg1[0] = Texture;
		ColorArg2[0] = Diffuse;
        AlphaOp[0]   = SelectArg2;
        AlphaArg1[0] = Texture;
		AlphaArg2[0] = Diffuse;
        
		AlphaBlendEnable = <alphaBlendEnable>;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;

		SpecularEnable = true;

		CullMode = None;
		NormalizeNormals = true;
	}

}

technique diffuse
{
	pass p0
	{
		MaterialDiffuse = <diffuseMaterial>;
		MaterialSpecular = <specularMaterial>;
        MaterialAmbient  = <ambientMaterial>;
		MaterialEmissive = <emissiveMaterial>;
		MaterialPower = <powerMaterial>;

		// 3 Point lights
		LightAttenuation0[0] = 1.0f;
		LightAttenuation1[0] = 0.0f;
		LightAttenuation2[0] = 0.0f;
        LightType[0]      = Point;
        LightDiffuse[0]   = <pointlight0Diffuse>;
        LightSpecular[0]  = <pointlight0Specular>; 
        LightAmbient[0]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[0]  = <pointlight0Position>;
        LightRange[0]     = 100000.0f;
		LightEnable[0] 	  = <pointlight0Enable>;

		LightAttenuation0[1] = 1.0f;
		LightAttenuation1[1] = 0.0f;
		LightAttenuation2[1] = 0.0f;
        LightType[1]      = Point;
        LightDiffuse[1]   = <pointlight1Diffuse>;
        LightSpecular[1]  = <pointlight1Specular>; 
        LightAmbient[1]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[1]  = <pointlight1Position>;
        LightRange[1]     = 100000.0f;
		LightEnable[1] 	  = <pointlight1Enable>;

		LightAttenuation0[2] = 1.0f;
		LightAttenuation1[2] = 0.0f;
		LightAttenuation2[2] = 0.0f;
        LightType[2]      = Point;
        LightDiffuse[2]   = <pointlight2Diffuse>;
        LightSpecular[2]  = <pointlight2Specular>; 
        LightAmbient[2]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[2]  = <pointlight2Position>;
        LightRange[2]     = 100000.0f;
		LightEnable[2] 	  = <pointlight2Enable>;

		// 4 Spot lights
		LightAttenuation0[3] = 1.0f;
		LightAttenuation1[3] = 0.0f;
		LightAttenuation2[3] = 0.0f;
		LightPhi[3]		  = <spotlight0Penumbra>;
		LightTheta[3]	  = <spotlight0Umbra>;
        LightType[3]      = Spot;
        LightDiffuse[3]   = <spotlight0Diffuse>;
        LightSpecular[3]  = <spotlight0Specular>; 
        LightAmbient[3]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[3]  = <spotlight0Position>;
        LightDirection[3]  = <spotlight0Direction>;
        LightRange[3]     = 100000.0f;
		LightFalloff[3]   = <spotlight0Falloff>;
		LightEnable[3] 	  = <spotlight0Enable>;

		LightAttenuation0[4] = 1.0f;
		LightAttenuation1[4] = 0.0f;
		LightAttenuation2[4] = 0.0f;
		LightPhi[4]		  = <spotlight1Penumbra>;
		LightTheta[4]	  = <spotlight1Umbra>;
        LightType[4]      = Spot;
        LightDiffuse[4]   = <spotlight1Diffuse>;
        LightSpecular[4]  = <spotlight1Specular>; 
        LightAmbient[4]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[4]  = <spotlight1Position>;
		LightDirection[4]  = <spotlight1Direction>;
        LightRange[4]     = 100000.0f;
		LightFalloff[4]   = <spotlight1Falloff>;
		LightEnable[4] 	  = <spotlight1Enable>;

		LightAttenuation0[5] = 1.0f;
		LightAttenuation1[5] = 0.0f;
		LightAttenuation2[5] = 0.0f;
		LightPhi[5]		  = <spotlight2Penumbra>;
		LightTheta[5]	  = <spotlight2Umbra>;
        LightType[5]      = Spot;
        LightDiffuse[5]   = <spotlight2Diffuse>;
        LightSpecular[5]  = <spotlight2Specular>; 
        LightAmbient[5]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[5]  = <spotlight2Position>;
		LightDirection[5]  = <spotlight2Direction>;
        LightRange[5]     = 100000.0f;
		LightFalloff[5]   = <spotlight2Falloff>;
		LightEnable[5] 	  = <spotlight2Enable>;

		LightAttenuation0[6] = 1.0f;
		LightAttenuation1[6] = 0.0f;
		LightAttenuation2[6] = 0.0f;
		LightPhi[6]		  = <spotlight3Penumbra>;
		LightTheta[6]	  = <spotlight3Umbra>;
        LightType[6]      = Spot;
        LightDiffuse[6]   = <spotlight3Diffuse>;
        LightSpecular[6]  = <spotlight3Specular>; 
        LightAmbient[6]   = {0.0f,0.0f,0.0f,0.0f};
        LightPosition[6]  = <spotlight3Position>;
		LightDirection[6]  = <spotlight3Direction>;
        LightRange[6]     = 100000.0f;
		LightFalloff[6]   = <spotlight3Falloff>;
		LightEnable[6] 	  = <spotlight3Enable>;

		// Enable lighting and turn light 0 on.
        
        Lighting = true;
        LocalViewer = <localViewerEnable>;

   		ZEnable = true;
		ZWriteEnable = true;

        DiffuseMaterialSource = Material;
  		SpecularMaterialSource = Material;
  		AmbientMaterialSource = Material;
  		EmissiveMaterialSource = Material;

        // Assign diffuse color to be used
        ColorOp[0]   = SelectArg2;
        ColorArg1[0] = Texture;
		ColorArg2[0] = Diffuse;
        AlphaOp[0]   = SelectArg2;
        AlphaArg1[0] = Texture;
		AlphaArg2[0] = Diffuse;
        
		AlphaBlendEnable = <alphaBlendEnable>;
		SrcBlend = SrcAlpha;
		DestBlend = InvSrcAlpha;

		SpecularEnable = true;

		CullMode = None;
		NormalizeNormals = true;
	}

}
